"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pipeMemberExpression = exports.isReactImport = exports.isReactRequire = exports.getReactIdent = exports.debugEffect = void 0;
const tslib_1 = require("tslib");
const t = tslib_1.__importStar(require("@babel/types"));
const Console = tslib_1.__importStar(require("effect/Console"));
const Option = tslib_1.__importStar(require("effect/Option"));
const debugEffect = (x) => Console.log(x);
exports.debugEffect = debugEffect;
const isCreateElementIdent = (node) => {
    return t.isIdentifier(node.property, { name: 'createElement' });
};
const getReactIdent = (x) => {
    if (t.isIdentifier(x.node.object, { name: 'react' }) ||
        t.isIdentifier(x.node.object, { name: 'React' })) {
        return x.node.object.name;
    }
    if (t.isMemberExpression(x.node.object) &&
        t.isIdentifier(x.node.object.object, { name: '_react' }) &&
        t.isIdentifier(x.node.object.property, { name: 'default' })) {
        return x.node.object.object.name;
    }
    return null;
};
exports.getReactIdent = getReactIdent;
const isReactRequire = (x) => {
    if (x.path.isVariableDeclarator() && t.isCallExpression(x.path.node.init)) {
        if (t.isIdentifier(x.path.node.init.callee, { name: 'require' }) &&
            t.isStringLiteral(x.path.node.init.arguments[0], { value: 'react' })) {
            return true;
        }
        else if (
        // const <name> = _interopRequireDefault(require("react"))
        (t.isIdentifier(x.path.node.init.callee, { name: '_interopRequireDefault' }) ||
            t.isIdentifier(x.path.node.init.callee, { name: '_interopRequireWildcard' }) ||
            t.isIdentifier(x.path.node.init.callee, { name: '_interopRequireWildcard' })) &&
            t.isCallExpression(x.path.node.init.arguments[0]) &&
            t.isIdentifier(x.path.node.init.arguments[0].callee, { name: 'require' }) &&
            t.isStringLiteral(x.path.node.init.arguments[0].arguments[0], {
                value: 'react',
            })) {
            return true;
        }
    }
    return false;
};
exports.isReactRequire = isReactRequire;
const isReactImport = (x) => {
    if (x.path.isImportSpecifier() ||
        x.path.isImportDefaultSpecifier() ||
        x.path.isImportDeclaration() ||
        x.path.isImportNamespaceSpecifier()) {
        return (t.isImportDeclaration(x.path.parentPath.node) &&
            x.path.parentPath.node.source.value.toLowerCase() === 'react');
    }
    return false;
};
exports.isReactImport = isReactImport;
const pipeMemberExpression = (self) => {
    return Option.Do.pipe(() => (isCreateElementIdent(self.node) ? Option.some(self) : Option.none()), Option.flatMapNullable(exports.getReactIdent), Option.flatMapNullable((x) => self.scope.getBinding(x)), Option.map((x) => (0, exports.isReactRequire)(x) || (0, exports.isReactImport)(x)), Option.getOrElse(() => false));
};
exports.pipeMemberExpression = pipeMemberExpression;
//# sourceMappingURL=path.effects.js.map