"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMemberExpressionProgram = void 0;
const tslib_1 = require("tslib");
const Effect = tslib_1.__importStar(require("effect/Effect"));
const Exit = tslib_1.__importStar(require("effect/Exit"));
const Option = tslib_1.__importStar(require("effect/Option"));
const services_1 = require("../services");
const createMemberExpressionProgram = (path) => {
    const context = (0, services_1.makeServiceLayer)(path);
    const program = Effect.gen(function* () {
        const createElement = yield* services_1.ReactService;
        const binding = yield* services_1.NodeBindingSvc;
        const callExp = yield* services_1.BabelService;
        const fromRequire = (x) => x.pipe(binding.getVariableDeclarator, binding.getCallExpression, (node) => [callExp.getReactRequire(node), callExp.isInteropRequire(node)], Option.firstSomeOf);
        return yield* createElement
            .getCreateElementExpression(path)
            .pipe((x) => x)
            .pipe(createElement.getReactIdent, binding.getBinding)
            .pipe((x) => [fromRequire(x), binding.getImportDeclaration(x)], Option.firstSomeOf);
    });
    return Effect.provide(program, context).pipe(Effect.runSyncExit, Exit.match({
        onFailure() {
            return false;
        },
        onSuccess() {
            return true;
        },
    }));
};
exports.createMemberExpressionProgram = createMemberExpressionProgram;
//# sourceMappingURL=programs.js.map