"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeBabelService = exports.BabelService = void 0;
const tslib_1 = require("tslib");
const t = tslib_1.__importStar(require("@babel/types"));
const Context = tslib_1.__importStar(require("effect/Context"));
const Layer = tslib_1.__importStar(require("effect/Layer"));
const Option = tslib_1.__importStar(require("effect/Option"));
class BabelService extends Context.Tag('CallExpressionSvc')() {
}
exports.BabelService = BabelService;
const allowedFileRegex = /^(?!.*[/\\](react|react-native|react-native-web|@native-twin\/*)[/\\]).*$/;
const isValidFile = (x = '') => allowedFileRegex.test(x);
const makeBabelService = (path) => Layer.succeed(BabelService, {
    path,
    isValidPath: (state) => {
        return isValidFile(state.filename);
    },
    getReactRequire(node) {
        return node.pipe(Option.flatMap(([, node]) => t.isIdentifier(node.callee, { name: 'require' }) &&
            t.isStringLiteral(node.arguments[0], { value: 'react' })
            ? Option.some(true)
            : Option.none()));
    },
    isInteropRequire(node) {
        return node.pipe(Option.flatMap(([, node]) => {
            if (
            // const <name> = _interopRequireDefault(require("react"))
            (t.isIdentifier(node.callee, { name: '_interopRequireDefault' }) ||
                t.isIdentifier(node.callee, { name: '_interopRequireWildcard' })) &&
                t.isCallExpression(node.arguments[0]) &&
                t.isIdentifier(node.arguments[0].callee, { name: 'require' }) &&
                t.isStringLiteral(node.arguments[0].arguments[0], {
                    value: 'react',
                })) {
                return Option.some(true);
            }
            return Option.none();
        }));
    },
});
exports.makeBabelService = makeBabelService;
//# sourceMappingURL=Babel.service.js.map