"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BindingServiceLive = exports.NodeBindingSvc = void 0;
const tslib_1 = require("tslib");
const t = tslib_1.__importStar(require("@babel/types"));
const Context = tslib_1.__importStar(require("effect/Context"));
const Effect = tslib_1.__importStar(require("effect/Effect"));
const Layer = tslib_1.__importStar(require("effect/Layer"));
const Option = tslib_1.__importStar(require("effect/Option"));
const Babel_service_1 = require("./Babel.service");
class NodeBindingSvc extends Context.Tag('NodeBindingSvc')() {
}
exports.NodeBindingSvc = NodeBindingSvc;
exports.BindingServiceLive = Layer.scoped(NodeBindingSvc, Effect.gen(function* () {
    const babelService = yield* Babel_service_1.BabelService;
    return {
        getBinding(node) {
            return node.pipe(Option.flatMap((a) => Option.fromNullable(babelService.path.scope.getBinding(a.name))));
        },
        getVariableDeclarator(binding) {
            return binding.pipe(Option.flatMap((x) => x.path.isVariableDeclarator() ? Option.some(x.path.node) : Option.none()));
        },
        getCallExpression(node) {
            return node.pipe(Option.flatMap((x) => t.isCallExpression(x.init)
                ? Option.some([x, x.init])
                : Option.none()));
        },
        getImportDeclaration(binding) {
            return binding.pipe(Option.flatMap((x) => x.path.parentPath &&
                t.isImportDeclaration(x.path.parentPath.node) &&
                x.path.parentPath.node.source.value.toLowerCase() === 'react'
                ? Option.some(true)
                : Option.none()));
        },
    };
}));
//# sourceMappingURL=NodeBinding.service.js.map