"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactLive = exports.ReactService = void 0;
const tslib_1 = require("tslib");
const t = tslib_1.__importStar(require("@babel/types"));
const Context = tslib_1.__importStar(require("effect/Context"));
const Effect = tslib_1.__importStar(require("effect/Effect"));
const Layer = tslib_1.__importStar(require("effect/Layer"));
const Option = tslib_1.__importStar(require("effect/Option"));
class ReactService extends Context.Tag('ReactService')() {
}
exports.ReactService = ReactService;
exports.ReactLive = Layer.scoped(ReactService, Effect.gen(function* () {
    return {
        getCreateElementExpression(path) {
            if (t.isIdentifier(path.node.property, { name: 'createElement' })) {
                return Option.some(path.node);
            }
            return Option.none();
        },
        getReactIdent(node) {
            return node.pipe(Option.flatMap((x) => {
                if (t.isIdentifier(x.object, { name: 'react' }) ||
                    t.isIdentifier(x.object, { name: 'React' })) {
                    return Option.some(x.object);
                }
                if (t.isMemberExpression(x.object) &&
                    t.isIdentifier(x.object.object, { name: '_react' }) &&
                    t.isIdentifier(x.object.property, { name: 'default' })) {
                    return Option.some(x.object.object);
                }
                return Option.none();
            }));
        },
    };
}));
//# sourceMappingURL=React.service.js.map